#include <gtk/gtk.h>
#include "configfile.h"
#include "yqtreeitem.h"
#include <sys/stat.h>


extern gchar sFilename[256];
extern GtkWidget *tree_main, *root_leaf;
extern gint yesnoreturn;
extern YqTreeItem *selectleaf;

void GetFilename (char *sTitle);
void Popup (gchar * szMessage);
GtkWidget *yq_createnulltree ();

void
file_close ()
{
	GList *list = NULL;
	gint n;
	ConfigFile *nowcfgfile;

	if (selectleaf->nodename[0] == '\0')
		return;
	list = gtk_container_children (GTK_CONTAINER (tree_main));
	n = 0;
	while (list)
	{
		n++;
		list = g_list_remove_link (list, list);
	}
	if (selectleaf->cfg->changed)
	{
		YesNo ("Ƿ񱣴?");
		if (yesnoreturn == 2)
			return;
		if (yesnoreturn == 1)
		{
			yq_cfg_write_file (selectleaf->cfg,
					   selectleaf->cfg->cfgfilename);
		}
	}
	yq_cfg_free (selectleaf->cfg);
	g_free (selectleaf->cfg);
	while (selectleaf->attree != GTK_TREE (tree_main))
		selectleaf = YQ_TREE_ITEM (selectleaf->attree->tree_owner);
	gtk_tree_remove_item (GTK_TREE (tree_main), GTK_WIDGET (selectleaf));
	if (!GTK_TREE_ITEM (root_leaf)->subtree)
	{
		tree_main = yq_createnulltree ();
		gtk_tree_item_set_subtree (GTK_TREE_ITEM (root_leaf),
					   tree_main);
	}
	gtk_tree_select_item (GTK_TREE (tree_main)->root_tree, 0);
}


void
file_saveas (GtkWidget * widget, gpointer data)
{
	struct stat st;

	GetFilename ("ΪYQļ");
	if (sFilename[0] == '\0')
		return;
	if (!stat (sFilename, &st))
	{
		Areyousure ("ļѾ,ȷʵҪ滻?");
		if (!yesnoreturn)
			return;
	}
	yq_cfg_write_file (selectleaf->cfg, sFilename);
}

/*
void
file_importcsv(GtkWidget *widget, gpointer data)
{
	gint a[100],b[100];
	struct stat stats;
	FILE *csvfile;
	gchar *buffer,,**lines;


	GetFilename(" CSV");
	if (sFilename[0]=='\0') return;
	if (lstat(sFilename,&stats)==-1) return;
	if (!(csvfile=fopen(sFilename,"r"))) return;
	buffer=g_malloc(stats.st_size+1);
	if(fread(buffer,1,stats.st_size,csvfile)!=stats.st_size)
	{
		g_free(buffer);
		fclose(csvfile);
		return;
	}
	fclose(csvfile);
	buffer[stats.st_size]='\0';
	
	lines=g_strsplit(buffer,"\n",0);
	g_free(buffer);
	for (i=1;lines[i];i++)
	{
		
	}
	while(lines[i])
	{
		if(lines[i][0]=='[')
		{	
			if((tmp=strchr(lines[i],']')))
			{
				*tmp='\0';
				section=yq_cfg_create_section(cfg,&lines[i][1]);
			}
		}
		else if(lines[i][0]!='#' && section)
		{
			if((tmp=strchr(lines[i],'=')))
			{
				*tmp='\0';
				tmp++;
				yq_cfg_create_string(section,lines[i],tmp);
			}
		}
		i++;
	}
	g_strfreev(lines);
	return cfg;



	gchar *ab,*a,bb[260],*c;

	if (*gtk_entry_get_text(GTK_ENTRY(nb_1_1))=='\0')
	{
		Popup(""); 
		return;    
	}
	ab=g_malloc(10000);
	a=ab;
	c=gtk_entry_get_text(GTK_ENTRY(nb_1_1));
	if (!nb_isadd) tree_set_text(GTK_TREE_ITEM(tree_selectitem),c);
	addtotext(&a,c);
	if (!strcmp(gtk_entry_get_text(GTK_ENTRY (GTK_COMBO(nb_1_2)->entry)),""))
	{
		strcpy(bb,"1");
		if (!nb_isadd) tree_set_pixmap(GTK_TREE_ITEM(tree_selectitem),BOY);
	} else
	{
		strcpy(bb,"0");
		if (!nb_isadd) tree_set_pixmap(GTK_TREE_ITEM(tree_selectitem),GIRL);
	}
	addtotext(&a,bb);
	if (!strcmp(gtk_entry_get_text(GTK_ENTRY (GTK_COMBO(nb_1_3)->entry)),""))
		strcpy(bb,"1");
	else
		strcpy(bb,"0");
	addtotext(&a,bb);
	addtotext(&a,gtk_entry_get_text(GTK_ENTRY(nb_1_5)));
	if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(nb_1_4)))
	strcpy(bb,"1");else strcpy(bb,"0");
	addtotext(&a,bb);
	addtotext(&a,gtk_entry_get_text(GTK_ENTRY(nb_1_6)));
	addtotext(&a,gtk_entry_get_text(GTK_ENTRY(nb_1_7)));
	addtotext(&a,gtk_entry_get_text(GTK_ENTRY(nb_1_8)));
	addtotext(&a,gtk_entry_get_text(GTK_ENTRY(nb_1_9)));
	addtotext(&a,gtk_entry_get_text(GTK_ENTRY(nb_1_10)));
	addtotext(&a,gtk_entry_get_text(GTK_ENTRY(nb_1_11)));
	addtotext(&a,gtk_entry_get_text(GTK_ENTRY(nb_1_12)));
	addtotext(&a,gtk_entry_get_text(GTK_ENTRY(nb_1_13)));
	addtotext(&a,gtk_entry_get_text(GTK_ENTRY(nb_1_14)));
	addtotext(&a,gtk_entry_get_text(GTK_ENTRY(nb_1_15)));
	addtotext(&a,gtk_entry_get_text(GTK_ENTRY(nb_1_16)));
	addtotext(&a,gtk_entry_get_text(GTK_ENTRY(nb_1_17)));
	addtotext(&a,gtk_entry_get_text(GTK_ENTRY(nb_1_18)));
	addtotext(&a,gtk_entry_get_text(GTK_ENTRY(nb_2_1)));
	addtotext(&a,gtk_entry_get_text(GTK_ENTRY(nb_2_2)));
	addtotext(&a,gtk_entry_get_text(GTK_ENTRY(nb_2_3)));
	addtotext(&a,gtk_entry_get_text(GTK_ENTRY(nb_2_4)));
	addtotext(&a,gtk_entry_get_text(GTK_ENTRY(nb_2_5)));
	addtotext(&a,gtk_entry_get_text(GTK_ENTRY(nb_2_6)));
	addtotext(&a,gtk_entry_get_text(GTK_ENTRY(nb_2_7)));
	addtotext(&a,gtk_entry_get_text(GTK_ENTRY(nb_2_8)));
	addtotext(&a,gtk_entry_get_text(GTK_ENTRY(nb_2_9)));
	addtotext(&a,gtk_entry_get_text(GTK_ENTRY(nb_2_10)));
	addtotext(&a,gtk_entry_get_text(GTK_ENTRY(nb_2_11)));
	addtotext(&a,gtk_entry_get_text(GTK_ENTRY(nb_2_12)));
	addtotext(&a,gtk_entry_get_text(GTK_ENTRY(nb_2_13)));
	c=gtk_editable_get_chars(GTK_EDITABLE(nb_3_1),(gint)0,(gint)-1);
	addtotext(&a,c);
	g_free(c);
	c=gtk_editable_get_chars(GTK_EDITABLE(nb_3_2),(gint)0,(gint)-1);
	addtotext(&a,c);
	g_free(c);
	a--;
	*a='\0';
	nb_setchanged(save_button,NULL);
	if (!nb_isadd)
		yq_cfg_write_string(cfgfile,tree_selectzuname,tree_selectjilu,ab);
	else
		toolbar_addjilu(ab);
	g_free(ab);
}*/
